#pragma config(I2C_Usage, I2C1, i2cSensors)
#pragma config(Sensor, dgtl11, lClawSol,       sensorDigitalOut)
#pragma config(Sensor, dgtl12, rClawSol,       sensorDigitalOut)
#pragma config(Sensor, I2C_1,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_2,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_3,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_4,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_5,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_6,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Motor,  port1,           lLiftMotor,    tmotorVex393TurboSpeed_HBridge, openLoop, encoderPort, I2C_5)
#pragma config(Motor,  port2,           rRearMotor,    tmotorVex393TurboSpeed_MC29, openLoop, encoderPort, I2C_1)
#pragma config(Motor,  port3,           lRearMotor,    tmotorVex393TurboSpeed_MC29, openLoop, encoderPort, I2C_4)
#pragma config(Motor,  port4,           rFrontMotor,   tmotorVex393TurboSpeed_MC29, openLoop, encoderPort, I2C_2)
#pragma config(Motor,  port5,           lFrontMotor,   tmotorVex393TurboSpeed_MC29, openLoop, encoderPort, I2C_3)
#pragma config(Motor,  port10,          rLiftMotor,    tmotorVex393TurboSpeed_HBridge, openLoop, encoderPort, I2C_6)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of Vex-920-2016, and is therefore licensed under the GNU GPLv3 public license.
// Copyright (C) 2016  Ganden Schaffner and James Fletcher

/* Controls
	Ch2: Move forward or backward
	Ch4: Rotate counterclockwise or clockwise
	Ch5D: Toggle the claw open or closed
	Ch6: Raise or lower the lift
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

// Global variables
#define M_PI acos(-1.0)

// Methods
/*! A method to move the bot based on direction and speed.
	\param direction an integer either 1 (forward), -1 (backward), or 0 (stop movement).
	\param speed an integer ranging from 0 to 127.
*/
void moveStraight(int direction, int speed) {
	if(-1 <= direction && direction <= 1) {
		motor[lRearMotor] = direction * speed;
		motor[rRearMotor] = direction * speed;
		motor[lFrontMotor] =  direction * speed;
		motor[rFrontMotor] =  direction * speed;
	}
	// else direction was not a valid input
}

/*! A method to move the bot based on direction, speed, and distance.
	\param direction an integer either 1 (forward), -1 (backward), or 0 (stop movement).
	\param speed an integer ranging from 0 to 127.
	\param distance a distance to travel, in inches.
*/
void moveDistance(int direction, int speed, int distance) {
	// The IEMs output 627.2 counts per revolution using using 393 torque motors.
	// Omni wheels have a radius of 2in, so their circum. is M_PI * 4.
	nMotorEncoder[lRearMotor] = 0;
	nMotorEncoder[rRearMotor] = 0;
	nMotorEncoder[lFrontMotor] = 0;
	nMotorEncoder[rFrontMotor] = 0;
	while(nMotorEncoder[rRearMotor] / -627.2 * (M_PI * 4) < distance * (6.0/7)) {
			// 6/7 is magic number. Without it, the bot travels too far.
		moveStraight(direction, speed);
	}
	moveStraight(0, 0);
}

/*! A method to move the bot based on joystick input.
	\param speed an integer ranging from 0 to 127.
*/
void moveStick(int speed) {
	motor[lRearMotor] = (vexRT[Ch4] + vexRT[Ch2]) * (speed / 127.0);
	motor[rRearMotor] = (-1 * vexRT[Ch4] + vexRT[Ch2]) * (speed / 127.0);
	motor[lFrontMotor] =  (-1 * vexRT[Ch4] + vexRT[Ch2]) * (speed / 127.0);
	motor[rFrontMotor] =  (vexRT[Ch4] + vexRT[Ch2]) * (speed / 127.0);
}

/*! A method to allow control of the bot's lift.
	\param speed an integer ranging from 0 to 127.
*/
void liftControls(int speed) {
	if(vexRT[Btn6U] == 1) {
		motor[rLiftMotor] = speed;
		motor[lLiftMotor] = speed;
	} else if(vexRT[Btn6D] == 1) {
		motor[rLiftMotor] = -1 * speed;
		motor[lLiftMotor] = -1 * speed;
	} else {
		motor[rLiftMotor] = 0;
		motor[lLiftMotor] = 0;
	}
	// A positive value lifts up on lLiftMotor
	// A positive value lifts up on rLiftMotor
}

/*! A method to allow control of the bot's claw.
*/
void clawControl() {
	if(vexRT[Btn5D] == 1) {
		SensorValue[lClawSol] = abs(SensorValue[lClawSol] - 1);
		SensorValue[rClawSol] = abs(SensorValue[rClawSol] - 1);
	}
}

/*---------------------------------------------------------------------------*/
/*                          Pre-Autonomous Functions                         */
/*                                                                           */
/*  You may want to perform some actions before the competition starts.      */
/*  Do them in the following function.  You must return from this function   */
/*  or the autonomous and usercontrol tasks will not be started.  This       */
/*  function is only called once after the cortex has been powered on and    */
/*  not every time that the robot is disabled.                               */
/*---------------------------------------------------------------------------*/

void pre_auton() {
	// Set bStopTasksBetweenModes to false if you want to keep user created tasks
	// running between Autonomous and Driver controlled modes. You will need to
	// manage all user created tasks if set to false.
	bStopTasksBetweenModes = true;

	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

task autonomous() {
	moveDistance(1, 127, 36);
}

task usercontrol() {
	while(true) {
		moveStick(127);
		liftControls(127);
		clawControl();
		wait1Msec(10); // This prevents the current task from hogging the CPU
	}
}
